/* Project 3 by David Taralla 16-02-2010
*
* This program executes a bisection search
* of the first value entered by the user in
* the array defined by next input values.
* Assumes that increasing values are given.
*/

#include <stdio.h>

static int indexOf(int *inWhat, int size, int intToFind);


int main() {
    const int LIST_LENGTH = 100;
    
    int intToFind;
    int intList[LIST_LENGTH];
    int nbOfEnteredInt = 0;
    
    int scanReturn = scanf("%d", &intToFind);
    
    while (nbOfEnteredInt < LIST_LENGTH) {
        // While conversions are succeeding AND nb of
        // conversions less than LIST_LENGTH,
        // registering %d from buffer in [intList]
        
        scanReturn = scanf("%d", &intList[nbOfEnteredInt]);
        
        if (scanReturn == 0 || scanReturn == EOF) {
            // Last scan didn't convert anything OR
            // user hit CTRL+D
            
            nbOfEnteredInt--;
            break;
        }
        
        nbOfEnteredInt++;
    }
    
    printf("\n%d\n", indexOf(intList, nbOfEnteredInt, intToFind));
    
    return 0;
}


static int indexOf(int *inWhat, int size, int intToFind) {
    // This function executes a bisection search
    // of [intToFind] in list [inWhat].
    // Returns index of [intToFind] in [inWhat].
    // Returns -1 if not found.
    
    int lowerEdge = 0;
    int upperEdge = size;
    int midValueIndex;
    
    while (lowerEdge != upperEdge) {
        midValueIndex = (lowerEdge + upperEdge) / 2;
        
        if (intToFind < inWhat[midValueIndex])
            upperEdge = midValueIndex;
            
        else if (intToFind > inWhat[midValueIndex])
            lowerEdge = midValueIndex + 1;
            
        else // intToFind == inWhat[midValueIndex]
            lowerEdge = upperEdge = midValueIndex;
    }
    
    if (inWhat[lowerEdge] == intToFind)
        return lowerEdge;
    
    // Else : not found
    return -1;
}
